searchData={"items":[{"type":"module","title":"oidcc","doc":"OpenID Connect High Level Interface Setup { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; , name =&gt; { local , google_config_provider } } ) . (or via a supervisor ) See oidcc_provider_configuration_worker for details Global Configuration max_clock_skew (default 0 ) - Maximum allowed clock skew for JWT exp / nbf validation","ref":"oidcc.html"},{"type":"function","title":"oidcc.client_credentials_token/4","doc":"Retrieve Client Credential Token See https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4 Examples { ok , # oidcc_token { } } = oidcc : client_credentials_token ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] } ) .","ref":"oidcc.html#client_credentials_token/4"},{"type":"function","title":"oidcc.create_redirect_url/4","doc":"Create Auth Redirect URL Examples { ok , RedirectUri } = oidcc : create_redirect_url ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; #{ redirect_uri : &lt;&lt; &quot;https://my.server/return&quot; } ) , %% RedirectUri = https://my.provider/auth?scope=openid&amp;response_type=code&amp;client_id=client_id&amp;redirect_uri=https%3A%2F%2Fmy.server%2Freturn","ref":"oidcc.html#create_redirect_url/4"},{"type":"function","title":"oidcc.initiate_logout_url/4","doc":"Create Initiate URI for Relaying Party initated Logout See https://openid.net/specs/openid-connect-rpinitiated-1_0.html#RPLogout Examples %% Get `Token` from `oidcc_token` { ok , RedirectUri } = oidcc : initiate_logout_url ( Token , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , #{ post_logout_redirect_uri : &lt;&lt; &quot;https://my.server/return&quot; } ) , %% RedirectUri = https://my.provider/logout?id_token_hint=IDToken&amp;client_id=ClientId&amp;post_logout_redirect_uri=https%3A%2F%2Fmy.server%2Freturn","ref":"oidcc.html#initiate_logout_url/4"},{"type":"function","title":"oidcc.introspect_token/5","doc":"Introspect the given access token Examples %% Get AccessToken { ok , # oidcc_token_introspection { active = True } } = oidcc : introspect_token ( AccessToken , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ } ) .","ref":"oidcc.html#introspect_token/5"},{"type":"function","title":"oidcc.jwt_profile_token/6","doc":"Retrieve JSON Web Token (JWT) Profile Token See https://datatracker.ietf.org/doc/html/rfc7523#section-4 Examples { ok , KeyJson } = file : read_file ( &quot;jwt-profile.json&quot; ) , KeyMap = jose : decode ( KeyJson ) , Key = jose_jwk : from_pem ( maps : get ( &lt;&lt; &quot;key&quot; &gt;&gt; , KeyMap ) ) , { ok , # oidcc_token { } } = oidcc_token : jwt_profile ( &lt;&lt; &quot;subject&quot; &gt;&gt; , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , Key , #{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] , kid =&gt; maps : get ( &lt;&lt; &quot;keyId&quot; &gt;&gt; , KeyMap ) } ) .","ref":"oidcc.html#jwt_profile_token/6"},{"type":"function","title":"oidcc.refresh_token/5","doc":"Refresh Token Examples %% Get Token and wait for its expiry { ok , # oidcc_token { } } = oidcc : refresh_token ( Token , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ expected_subject =&gt; &lt;&lt; &quot; sub_from_initial_id_token &gt;&gt; } ) .","ref":"oidcc.html#refresh_token/5"},{"type":"function","title":"oidcc.retrieve_token/5","doc":"retrieve the token using the authcode received before and directly validate the result. the authcode was sent to the local endpoint by the OpenId Connect provider, using redirects Examples %% Get AuthCode from Redirect { ok , # oidcc_token { } } = oidcc : retrieve_token ( AuthCode , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) .","ref":"oidcc.html#retrieve_token/5"},{"type":"function","title":"oidcc.retrieve_userinfo/5","doc":"Load userinfo for the given token Examples %% Get Token { ok , #{ &lt;&lt; &quot;sub&quot; &gt;&gt; =&gt; Sub } } = oidcc : retrieve_userinfo ( Token , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ } ) .","ref":"oidcc.html#retrieve_userinfo/5"},{"type":"module","title":"oidcc_authorization","doc":"Functions to start an OpenID Connect Authorization","ref":"oidcc_authorization.html"},{"type":"function","title":"oidcc_authorization.create_redirect_url/2","doc":"Create Auth Redirect URL For a high level interface using oidcc_provider_configuration_worker see oidcc:create_redirect_url/4 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , { ok , RedirectUri } = oidcc_authorization : create_redirect_url ( ClientContext , #{ redirect_uri : &lt;&lt; &quot;https://my.server/return&quot; } ) , %% RedirectUri = https://my.provider/auth?scope=openid&amp;response_type=code&amp;client_id=client_id&amp;redirect_uri=https%3A%2F%2Fmy.server%2Freturn","ref":"oidcc_authorization.html#create_redirect_url/2"},{"type":"type","title":"oidcc_authorization.error/0","doc":null,"ref":"oidcc_authorization.html#t:error/0"},{"type":"type","title":"oidcc_authorization.opts/0","doc":"Configure authorization redirect url See https://openid.net/specs/openid-connect-core-1_0.html#AuthRequest Parameters scopes - list of scopes to request (defaults to [&lt;&lt;&quot;openid&quot;&gt;&gt;] ) state - state to pass to the provider nonce - nonce to pass to the provider pkce_verifier - pkce verifier (random string), see https://datatracker.ietf.org/doc/html/rfc7636#section-4.1 redirect_uri - redirect target after authorization is completed url_extension - add custom query parameters to the authorization url","ref":"oidcc_authorization.html#t:opts/0"},{"type":"module","title":"oidcc_client_context","doc":"Client Configuration for authorization, token exchange and userinfo For most projects, it makes sense to use oidcc_provider_configuration_worker and the high-level interface of oidcc . In that case direct usage of this module is not needed. To use the record, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_client_context.hrl&quot; ] ) .","ref":"oidcc_client_context.html"},{"type":"function","title":"oidcc_client_context.from_configuration_worker/3","doc":"Create Client Context from a oidcc_provider_configuration_worker See from_configuration_worker/4","ref":"oidcc_client_context.html#from_configuration_worker/3"},{"type":"function","title":"oidcc_client_context.from_configuration_worker/4","doc":"Create Client Context from a oidcc_provider_configuration_worker Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://login.salesforce.com&quot; &gt;&gt; } ) , { ok , # oidcc_client_context { } } = oidcc_client_context : from_configuration_worker ( Pid , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) . { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://login.salesforce.com&quot; &gt;&gt; , name =&gt; { local , salesforce_provider } } ) , { ok , # oidcc_client_context { } } = oidcc_client_context : from_configuration_worker ( $ salesforce_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ client_jwks =&gt; jose_jwk : generate_key ( 16 ) } ) .","ref":"oidcc_client_context.html#from_configuration_worker/4"},{"type":"function","title":"oidcc_client_context.from_manual/4","doc":"Create Client Context manually See from_manual/5","ref":"oidcc_client_context.html#from_manual/4"},{"type":"function","title":"oidcc_client_context.from_manual/5","doc":"Create Client Context manually Examples { ok , Configuration } = oidcc_provider_configuration : load_configuration ( &lt;&lt; &quot;https://login.salesforce.com&quot; &gt;&gt; , [ ] ) , # oidcc_provider_configuration { jwks_uri = JwksUri } = Configuration , { ok , Jwks } = oidcc_provider_configuration : load_jwks ( JwksUri , [ ] ) . # oidcc_client_context { } = oidcc_client_context : from_manual ( Metdata , Jwks , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , #{ client_jwks =&gt; jose_jwk : generate_key ( 16 ) } ) .","ref":"oidcc_client_context.html#from_manual/5"},{"type":"type","title":"oidcc_client_context.authenticated_opts/0","doc":null,"ref":"oidcc_client_context.html#t:authenticated_opts/0"},{"type":"type","title":"oidcc_client_context.authenticated_t/0","doc":null,"ref":"oidcc_client_context.html#t:authenticated_t/0"},{"type":"type","title":"oidcc_client_context.error/0","doc":null,"ref":"oidcc_client_context.html#t:error/0"},{"type":"type","title":"oidcc_client_context.opts/0","doc":null,"ref":"oidcc_client_context.html#t:opts/0"},{"type":"type","title":"oidcc_client_context.t/0","doc":null,"ref":"oidcc_client_context.html#t:t/0"},{"type":"type","title":"oidcc_client_context.unauthenticated_opts/0","doc":null,"ref":"oidcc_client_context.html#t:unauthenticated_opts/0"},{"type":"type","title":"oidcc_client_context.unauthenticated_t/0","doc":null,"ref":"oidcc_client_context.html#t:unauthenticated_t/0"},{"type":"module","title":"oidcc_client_registration","doc":"Dynamic Client Registration Utilities See https://openid.net/specs/openid-connect-registration-1_0.html#ClientMetadata Records To use the record, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_client_registration.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.ClientRegistration'","ref":"oidcc_client_registration.html"},{"type":"function","title":"oidcc_client_registration.register/3","doc":"Register Client Examples { ok , ProviderConfiguration } = oidcc_provider_configuration : load_configuration ( &quot;https://your.issuer&quot; ) , { ok , # oidcc_client_registration_response { client_id = ClientId , client_secret = ClientSecret } } = oidcc_client_registration : register ( ProviderConfiguration , # oidcc_client_registration { redirect_uris = [ &quot;https://your.application.com/oidcc/callback&quot; ] } , #{ initial_access_token =&gt; &lt;&lt; &quot;optional token you got from the provider&quot; &gt;&gt; } ) .","ref":"oidcc_client_registration.html#register/3"},{"type":"type","title":"oidcc_client_registration.error/0","doc":null,"ref":"oidcc_client_registration.html#t:error/0"},{"type":"type","title":"oidcc_client_registration.opts/0","doc":"Configure configuration loading / parsing Parameters initial_access_token - Access Token for registration request_opts - config for HTTP request","ref":"oidcc_client_registration.html#t:opts/0"},{"type":"type","title":"oidcc_client_registration.response/0","doc":null,"ref":"oidcc_client_registration.html#t:response/0"},{"type":"type","title":"oidcc_client_registration.t/0","doc":null,"ref":"oidcc_client_registration.html#t:t/0"},{"type":"module","title":"oidcc_decode_util","doc":"Response Decoding Utils","ref":"oidcc_decode_util.html"},{"type":"type","title":"oidcc_decode_util.error/0","doc":null,"ref":"oidcc_decode_util.html#t:error/0"},{"type":"module","title":"oidcc_http_util","doc":"HTTP Client Utilities","ref":"oidcc_http_util.html"},{"type":"type","title":"oidcc_http_util.error/0","doc":null,"ref":"oidcc_http_util.html#t:error/0"},{"type":"type","title":"oidcc_http_util.http_header/0","doc":"See httpc:request/5","ref":"oidcc_http_util.html#t:http_header/0"},{"type":"type","title":"oidcc_http_util.httpc_error/0","doc":"See httpc:request/5 for additional errors","ref":"oidcc_http_util.html#t:httpc_error/0"},{"type":"type","title":"oidcc_http_util.query_params/0","doc":"See uri_string:compose_query/1","ref":"oidcc_http_util.html#t:query_params/0"},{"type":"type","title":"oidcc_http_util.request_opts/0","doc":"See httpc:request/5 Parameters timeout - timeout for request ssl - TLS config","ref":"oidcc_http_util.html#t:request_opts/0"},{"type":"type","title":"oidcc_http_util.telemetry_opts/0","doc":null,"ref":"oidcc_http_util.html#t:telemetry_opts/0"},{"type":"module","title":"oidcc_jwt_util","doc":"JWT Utilities","ref":"oidcc_jwt_util.html"},{"type":"type","title":"oidcc_jwt_util.claims/0","doc":null,"ref":"oidcc_jwt_util.html#t:claims/0"},{"type":"type","title":"oidcc_jwt_util.error/0","doc":null,"ref":"oidcc_jwt_util.html#t:error/0"},{"type":"type","title":"oidcc_jwt_util.refresh_jwks_for_unknown_kid_fun/0","doc":null,"ref":"oidcc_jwt_util.html#t:refresh_jwks_for_unknown_kid_fun/0"},{"type":"module","title":"oidcc_logout","doc":"Logout from the OpenID Provider","ref":"oidcc_logout.html"},{"type":"function","title":"oidcc_logout.initiate_url/3","doc":"Initiate URI for Relaying Party initated Logout See https://openid.net/specs/openid-connect-rpinitiated-1_0.html#RPLogout For a high level interface using oidcc_provider_configuration_worker see oidcc:initiate_logout_url/4 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , unauthenticated ) , %% Get `Token` from `oidcc_token` { ok , RedirectUri } = oidcc_logout : initiate_url ( Token , ClientContext , #{ post_logout_redirect_uri : &lt;&lt; &quot;https://my.server/return&quot; } ) , %% RedirectUri = https://my.provider/logout?id_token_hint=IDToken&amp;client_id=ClientId&amp;post_logout_redirect_uri=https%3A%2F%2Fmy.server%2Freturn","ref":"oidcc_logout.html#initiate_url/3"},{"type":"type","title":"oidcc_logout.error/0","doc":null,"ref":"oidcc_logout.html#t:error/0"},{"type":"type","title":"oidcc_logout.initiate_url_opts/0","doc":"Configure Relaying Party initiated Logout URI See https://openid.net/specs/openid-connect-rpinitiated-1_0.html#RPLogout Parameters logout_hint - logout_hint to pass to the provider post_logout_redirect_uri - Post Logout Redirect URI to pass to the provider state - state to pass to the provider ui_locales - UI locales to pass to the provider extra_query_params - extra query params to add to the uri","ref":"oidcc_logout.html#t:initiate_url_opts/0"},{"type":"module","title":"oidcc_provider_configuration","doc":"Tooling to load and parse Openid Configuration Records To use the record, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_provider_configuration.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.ProviderConfiguration'","ref":"oidcc_provider_configuration.html"},{"type":"function","title":"oidcc_provider_configuration.decode_configuration/1","doc":"See also: decode_configuration/2 .","ref":"oidcc_provider_configuration.html#decode_configuration/1"},{"type":"function","title":"oidcc_provider_configuration.decode_configuration/2","doc":"Decode JSON into a oidcc_provider_configuration:t() record Examples { ok , { { &quot;HTTP/1.1&quot; , 200 , &quot;OK&quot; } , _ Headers , Body } } = httpc : request ( &quot;https://accounts.google.com/.well-known/openid-configuration&quot; ) , { ok , DecodedJson } = your_json_lib : decode ( Body ) , { ok , # oidcc_provider_configuration { } } = oidcc_provider_configuration : decode_configuration ( DecodedJson ) .","ref":"oidcc_provider_configuration.html#decode_configuration/2"},{"type":"function","title":"oidcc_provider_configuration.load_configuration/1","doc":"See also: load_configuration/2 .","ref":"oidcc_provider_configuration.html#load_configuration/1"},{"type":"function","title":"oidcc_provider_configuration.load_configuration/2","doc":"Load OpenID Configuration into a oidcc_provider_configuration:t() record Examples { ok , # oidcc_provider_configuration { } } = oidcc_provider_configuration : load_configuration ( &quot;https://accounts.google.com&quot; ) .","ref":"oidcc_provider_configuration.html#load_configuration/2"},{"type":"function","title":"oidcc_provider_configuration.load_jwks/2","doc":"Load JWKs into a jose_jwk:key() record Examples { ok , # jose_jwk { } } = oidcc_provider_configuration : load_jwks ( &quot;https://www.googleapis.com/oauth2/v3/certs&quot; ) .","ref":"oidcc_provider_configuration.html#load_jwks/2"},{"type":"type","title":"oidcc_provider_configuration.error/0","doc":null,"ref":"oidcc_provider_configuration.html#t:error/0"},{"type":"type","title":"oidcc_provider_configuration.opts/0","doc":"Configure configuration loading / parsing Parameters fallback_expiry - How long to keep configuration cached if the server doesn't specify expiry request_opts - config for HTTP request","ref":"oidcc_provider_configuration.html#t:opts/0"},{"type":"type","title":"oidcc_provider_configuration.quirks/0","doc":"Allow Specification Non-compliance Exceptions allow_issuer_mismatch - Allow issuer mismatch between config issuer and function parameter allow_unsafe_http - Allow unsafe HTTP. Use this for development providers and never in production .","ref":"oidcc_provider_configuration.html#t:quirks/0"},{"type":"type","title":"oidcc_provider_configuration.t/0","doc":"Record containing OpenID and OAuth 2.0 Configuration See https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata , https://datatracker.ietf.org/doc/html/draft-jones-oauth-discovery-01#section-4.1 and https://openid.net/specs/openid-connect-rpinitiated-1_0.html#OPMetadata All unrecognized fields are stored in extra_fields .","ref":"oidcc_provider_configuration.html#t:t/0"},{"type":"module","title":"oidcc_provider_configuration_worker","doc":"OIDC Config Provider Worker Loads and continuously refreshes the OIDC configuration and JWKs The worker supports reading values concurrently via an ets table. To use this performance improvement, the worker has to be registered with a {local, Name} . No name / {global, Name} and {via, RegModule, ViaName} are not supported.","ref":"oidcc_provider_configuration_worker.html"},{"type":"function","title":"oidcc_provider_configuration_worker.get_jwks/1","doc":"Get Parsed Jwks","ref":"oidcc_provider_configuration_worker.html#get_jwks/1"},{"type":"function","title":"oidcc_provider_configuration_worker.get_provider_configuration/1","doc":"Get Configuration","ref":"oidcc_provider_configuration_worker.html#get_provider_configuration/1"},{"type":"function","title":"oidcc_provider_configuration_worker.refresh_configuration/1","doc":"Refresh Configuration Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ) . %% Later oidcc_provider_configuration_worker : refresh_configuration ( Pid ) .","ref":"oidcc_provider_configuration_worker.html#refresh_configuration/1"},{"type":"function","title":"oidcc_provider_configuration_worker.refresh_jwks/1","doc":"Refresh JWKs Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ) . %% Later oidcc_provider_configuration_worker : refresh_jwks ( Pid ) .","ref":"oidcc_provider_configuration_worker.html#refresh_jwks/1"},{"type":"function","title":"oidcc_provider_configuration_worker.refresh_jwks_for_unknown_kid/2","doc":"Refresh JWKs if the provided Kid is not matching any currently loaded keys Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ) . oidcc_provider_configuration_worker : refresh_jwks_for_unknown_kid ( Pid , &lt;&lt; &quot;kid&quot; &gt;&gt; ) .","ref":"oidcc_provider_configuration_worker.html#refresh_jwks_for_unknown_kid/2"},{"type":"function","title":"oidcc_provider_configuration_worker.start_link/1","doc":"Start Configuration Provider Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( #{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; , name =&gt; { local , google_config_provider } } ) . %% ... - behaviour ( supervisor ) . %% ... init ( _ opts ) -&gt; SupFlags = #{ strategy =&gt; one_for_one , intensity =&gt; 1 , period =&gt; 5 } , ChildSpecs = [ #{ id =&gt; google_config_provider , start =&gt; { oidcc_provider_configuration_worker , start_link , [ #{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ] } , restart =&gt; permanent , type =&gt; worker , modules =&gt; [ oidcc_provider_configuration_worker ] } ] , { ok , { SupFlags , ChildSpecs } } .","ref":"oidcc_provider_configuration_worker.html#start_link/1"},{"type":"type","title":"oidcc_provider_configuration_worker.opts/0","doc":null,"ref":"oidcc_provider_configuration_worker.html#t:opts/0"},{"type":"module","title":"oidcc_scope","doc":"OpenID Scope Utilities","ref":"oidcc_scope.html"},{"type":"function","title":"oidcc_scope.parse/1","doc":"Parse t() into scopes() Examples [ &lt;&lt; &quot;openid&quot; &gt;&gt; , &lt;&lt; &quot;profile&quot; &gt;&gt; ] = oidcc_scope : parse ( &lt;&lt; &quot;openid profile&quot; &gt;&gt; ) .","ref":"oidcc_scope.html#parse/1"},{"type":"function","title":"oidcc_scope.scopes_to_bin/1","doc":"Compose scopes() into t() Examples &lt;&lt; &quot;openid profile email&quot; &gt;&gt; = oidcc_scope : scopes_to_bin ( [ &lt;&lt; &quot;openid&quot; &gt;&gt; , profile , &quot;email&quot; ] ) .","ref":"oidcc_scope.html#scopes_to_bin/1"},{"type":"type","title":"oidcc_scope.scopes/0","doc":null,"ref":"oidcc_scope.html#t:scopes/0"},{"type":"type","title":"oidcc_scope.t/0","doc":null,"ref":"oidcc_scope.html#t:t/0"},{"type":"module","title":"oidcc_token","doc":"Facilitate OpenID Code/Token Exchanges Records To use the records, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_token.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.Token'","ref":"oidcc_token.html"},{"type":"function","title":"oidcc_token.client_credentials/2","doc":"Retrieve Client Credential Token See https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4 For a high level interface using oidcc_provider_configuration_worker see oidcc:client_credentials_token/4 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , { ok , # oidcc_token { } } = oidcc_token : client_credentials ( ClientContext , #{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] } ) .","ref":"oidcc_token.html#client_credentials/2"},{"type":"function","title":"oidcc_token.jwt_profile/4","doc":"Retrieve JSON Web Token (JWT) Profile Token See https://datatracker.ietf.org/doc/html/rfc7523#section-4 For a high level interface using oidcc_provider_configuration_worker see oidcc:jwt_profile_token/6 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , { ok , KeyJson } = file : read_file ( &quot;jwt-profile.json&quot; ) , KeyMap = jose : decode ( KeyJson ) , Key = jose_jwk : from_pem ( maps : get ( &lt;&lt; &quot;key&quot; &gt;&gt; , KeyMap ) ) , { ok , # oidcc_token { } } = oidcc_token : jwt_profile ( &lt;&lt; &quot;subject&quot; &gt;&gt; , ClientContext , Key , #{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] , kid =&gt; maps : get ( &lt;&lt; &quot;keyId&quot; &gt;&gt; , KeyMap ) } ) .","ref":"oidcc_token.html#jwt_profile/4"},{"type":"function","title":"oidcc_token.refresh/3","doc":"Refresh Token For a high level interface using oidcc_provider_configuration_worker see oidcc:refresh_token/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get AuthCode from Redirect { ok , Token } = oidcc_token : retrieve ( AuthCode , ClientContext , #{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) . %% Later { ok , # oidcc_token { } } = oidcc_token : refresh ( Token , ClientContext , #{ expected_subject =&gt; &lt;&lt; &quot; sub_from_initial_id_token &gt;&gt; } ) .","ref":"oidcc_token.html#refresh/3"},{"type":"function","title":"oidcc_token.retrieve/3","doc":"retrieve the token using the authcode received before and directly validate the result. the authcode was sent to the local endpoint by the OpenId Connect provider, using redirects For a high level interface using oidcc_provider_configuration_worker see oidcc:retrieve_token/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get AuthCode from Redirect { ok , # oidcc_token { } } = oidcc : retrieve ( AuthCode , ClientContext , #{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) .","ref":"oidcc_token.html#retrieve/3"},{"type":"function","title":"oidcc_token.validate_id_token/3","doc":"Validate ID Token Usually the id token is validated using retrieve/3 . If you gget the token passed from somewhere else, this function can validate it. Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get IdToken from somewhere { ok , Claims } = oidcc : validate_id_token ( IdToken , ClientContext , ExpectedNonce ) .","ref":"oidcc_token.html#validate_id_token/3"},{"type":"type","title":"oidcc_token.access/0","doc":"Access Token Wrapper Fields token - The retrieved token expires - Number of seconds the token is valid","ref":"oidcc_token.html#t:access/0"},{"type":"type","title":"oidcc_token.auth_method/0","doc":null,"ref":"oidcc_token.html#t:auth_method/0"},{"type":"type","title":"oidcc_token.client_credentials_opts/0","doc":null,"ref":"oidcc_token.html#t:client_credentials_opts/0"},{"type":"type","title":"oidcc_token.error/0","doc":null,"ref":"oidcc_token.html#t:error/0"},{"type":"type","title":"oidcc_token.id/0","doc":null,"ref":"oidcc_token.html#t:id/0"},{"type":"type","title":"oidcc_token.jwt_profile_opts/0","doc":null,"ref":"oidcc_token.html#t:jwt_profile_opts/0"},{"type":"type","title":"oidcc_token.refresh/0","doc":"Refresh Token Wrapper Fields token - The retrieved token","ref":"oidcc_token.html#t:refresh/0"},{"type":"type","title":"oidcc_token.refresh_opts/0","doc":"Options for refreshing a token See https://datatracker.ietf.org/doc/html/rfc6749#section-4.1.3 Fields scope - Scope to store with the token refresh_jwks - How to handle tokens with an unknown kid . See oidcc_jwt_util:refresh_jwks_for_unknown_kid_fun() expected_subject - sub of the original token","ref":"oidcc_token.html#t:refresh_opts/0"},{"type":"type","title":"oidcc_token.refresh_opts_no_sub/0","doc":"See refresh_opts_no_sub()","ref":"oidcc_token.html#t:refresh_opts_no_sub/0"},{"type":"type","title":"oidcc_token.retrieve_opts/0","doc":"Options for retrieving a token See https://datatracker.ietf.org/doc/html/rfc6749#section-4.1.3 Fields pkce_verifier - pkce verifier (random string previously given to oidcc_authorization ), see https://datatracker.ietf.org/doc/html/rfc7636#section-4.1 nonce - Nonce to check scope - Scope to store with the token refresh_jwks - How to handle tokens with an unknown kid . See oidcc_jwt_util:refresh_jwks_for_unknown_kid_fun() redirect_uri - Redirect uri given to oidcc_authorization:create_redirect_url/2","ref":"oidcc_token.html#t:retrieve_opts/0"},{"type":"type","title":"oidcc_token.t/0","doc":"Token Response Wrapper Fields id - id() access - access() refresh - refresh() scope - oidcc_scope:scopes()","ref":"oidcc_token.html#t:t/0"},{"type":"module","title":"oidcc_token_introspection","doc":"OAuth Token Introspection See https://datatracker.ietf.org/doc/html/rfc7662 Records To use the records, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_token_introspection.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.TokenIntrospection'","ref":"oidcc_token_introspection.html"},{"type":"function","title":"oidcc_token_introspection.introspect/3","doc":"Introspect the given access token For a high level interface using oidcc_provider_configuration_worker see oidcc:introspect_token/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get AccessToken { ok , # oidcc_token_introspection { active = True } } = oidcc_token_introspection : introspect ( AccessToken , ClientContext , #{ } ) .","ref":"oidcc_token_introspection.html#introspect/3"},{"type":"type","title":"oidcc_token_introspection.error/0","doc":null,"ref":"oidcc_token_introspection.html#t:error/0"},{"type":"type","title":"oidcc_token_introspection.opts/0","doc":null,"ref":"oidcc_token_introspection.html#t:opts/0"},{"type":"type","title":"oidcc_token_introspection.t/0","doc":"Introspection Result See https://datatracker.ietf.org/doc/html/rfc7662#section-2.2","ref":"oidcc_token_introspection.html#t:t/0"},{"type":"module","title":"oidcc_userinfo","doc":"OpenID Connect Userinfo See https://openid.net/specs/openid-connect-core-1_0.html#UserInfo Telemetry See 'Elixir.Oidcc.Userinfo'","ref":"oidcc_userinfo.html"},{"type":"function","title":"oidcc_userinfo.retrieve/3","doc":"Load userinfo for the given token For a high level interface using oidcc_provider_configuration_worker see oidcc:retrieve_userinfo/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get Token { ok , #{ &lt;&lt; &quot;sub&quot; &gt;&gt; =&gt; Sub } } = oidcc_userinfo : retrieve ( Token , ClientContext , #{ } ) .","ref":"oidcc_userinfo.html#retrieve/3"},{"type":"type","title":"oidcc_userinfo.error/0","doc":null,"ref":"oidcc_userinfo.html#t:error/0"},{"type":"type","title":"oidcc_userinfo.retrieve_opts/0","doc":"Configure userinfo request See https://openid.net/specs/openid-connect-core-1_0.html#UserInfoRequest Parameters refresh_jwks - How to handle tokens with an unknown kid . See oidcc_jwt_util:refresh_jwks_for_unknown_kid_fun() expected_subject - expected subject for the userinfo ( sub from id token)","ref":"oidcc_userinfo.html#t:retrieve_opts/0"},{"type":"type","title":"oidcc_userinfo.retrieve_opts_no_sub/0","doc":"See retrieve_opts()","ref":"oidcc_userinfo.html#t:retrieve_opts_no_sub/0"},{"type":"module","title":"Oidcc","doc":"OpenID Connect High Level Interface","ref":"Oidcc.html"},{"type":"module","title":"Setup - Oidcc","doc":"{:ok, _pid} =\n      Oidcc.ProviderConfiguration.Worker.start_link(%{\n      issuer: \"https://accounts.google.com\",\n      name: MyApp.GoogleConfigProvider\n    })\n\nor via a supervisor\n\n    Supervisor.init([\n      {Oidcc.ProviderConfiguration.Worker, %{issuer: \"https://accounts.google.com\"}}\n    ], strategy: :one_for_one)","ref":"Oidcc.html#module-setup"},{"type":"module","title":"Global Configuration - Oidcc","doc":"* `max_clock_skew` (default `0`) - Maximum allowed clock skew for JWT\n  `exp` / `nbf` validation","ref":"Oidcc.html#module-global-configuration"},{"type":"function","title":"Oidcc.client_credentials_token/4","doc":"Retrieve Client Credential Token\n\nSee https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4","ref":"Oidcc.html#client_credentials_token/4"},{"type":"function","title":"Examples - Oidcc.client_credentials_token/4","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://erlef-test-w4a8z2.zitadel.cloud\"\n    ...>   })\n    ...>\n    ...> {:ok, %Oidcc.Token{}} =\n    ...>   Oidcc.client_credentials_token(\n    ...>     pid,\n    ...>     System.fetch_env!(\"CLIENT_CREDENTIALS_CLIENT_ID\"),\n    ...>     System.fetch_env!(\"CLIENT_CREDENTIALS_CLIENT_SECRET\"),\n    ...>     %{scope: [\"scope\"]}\n    ...>   )","ref":"Oidcc.html#client_credentials_token/4-examples"},{"type":"function","title":"Oidcc.create_redirect_url/4","doc":"Create Auth Redirect URL","ref":"Oidcc.html#create_redirect_url/4"},{"type":"function","title":"Examples - Oidcc.create_redirect_url/4","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\"\n    ...> })\n    ...>\n    ...> {:ok, _redirect_uri} =\n    ...>   Oidcc.create_redirect_url(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\",\n    ...>     %{redirect_uri: \"https://my.server/return\"}\n    ...>   )","ref":"Oidcc.html#create_redirect_url/4-examples"},{"type":"function","title":"Oidcc.initiate_logout_url/4","doc":"Create Initiate URI for Relaying Party initated Logout\n\nSee [https://openid.net/specs/openid-connect-rpinitiated-1_0.html#RPLogout]","ref":"Oidcc.html#initiate_logout_url/4"},{"type":"function","title":"Examples - Oidcc.initiate_logout_url/4","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://erlef-test-w4a8z2.zitadel.cloud\"\n    ...>   })\n    ...>\n    ...> # Get access_token from Oidcc.Token.retrieve/3\n    ...> token = \"token\"\n    ...>\n    ...> {:ok, _redirect_uri} = Oidcc.initiate_logout_url(\n    ...>   token,\n    ...>   pid,\n    ...>   \"client_id\"\n    ...> )","ref":"Oidcc.html#initiate_logout_url/4-examples"},{"type":"function","title":"Oidcc.introspect_token/5","doc":"Introspect the given access token","ref":"Oidcc.html#introspect_token/5"},{"type":"function","title":"Examples - Oidcc.introspect_token/5","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> Oidcc.introspect_token(\n    ...>   \"access_token\",\n    ...>   pid,\n    ...>   \"client_id\",\n    ...>   \"client_secret\"\n    ...> )\n    ...> # => {:ok, %Oidcc.TokenIntrospection{}}","ref":"Oidcc.html#introspect_token/5-examples"},{"type":"function","title":"Oidcc.jwt_profile_token/6","doc":"Retrieve JSON Web Token (JWT) Profile Token\n\nhttps://datatracker.ietf.org/doc/html/rfc7523#section-4","ref":"Oidcc.html#jwt_profile_token/6"},{"type":"function","title":"Examples - Oidcc.jwt_profile_token/6","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://erlef-test-w4a8z2.zitadel.cloud\"\n    ...>   })\n    ...>\n    ...> %{\"key\" => key, \"keyId\" => kid, \"userId\" => subject} = \"JWT_PROFILE\"\n    ...>   |> System.fetch_env!()\n    ...>   |> JOSE.decode()\n    ...>\n    ...> jwk = JOSE.JWK.from_pem(key)\n    ...>\n    ...> {:ok, %Oidcc.Token{}} =\n    ...>   Oidcc.jwt_profile_token(\n    ...>     subject,\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\",\n    ...>     jwk,\n    ...>     %{scope: [\"urn:zitadel:iam:org:project:id:zitadel:aud\"], kid: kid}\n    ...>   )","ref":"Oidcc.html#jwt_profile_token/6-examples"},{"type":"function","title":"Oidcc.refresh_token/5","doc":"Refresh Token","ref":"Oidcc.html#refresh_token/5"},{"type":"function","title":"Examples - Oidcc.refresh_token/5","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> # Get refresh_token fromm redirect\n    ...> refresh_token = \"refresh_token\"\n    ...>\n    ...> Oidcc.refresh_token(\n    ...>   refresh_token,\n    ...>   pid,\n    ...>   \"client_id\",\n    ...>   \"client_secret\",\n    ...>   %{expected_subject: \"sub_from_initial_id_token\"}\n    ...> )\n    ...> # => {:ok, %Oidcc.Token{}}","ref":"Oidcc.html#refresh_token/5-examples"},{"type":"function","title":"Oidcc.retrieve_token/5","doc":"retrieve the token using the authcode received before and directly validate\nthe result.\n\nthe authcode was sent to the local endpoint by the OpenId Connect provider,\nusing redirects","ref":"Oidcc.html#retrieve_token/5"},{"type":"function","title":"Examples - Oidcc.retrieve_token/5","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> # Get auth_code fromm redirect\n    ...> auth_code = \"auth_code\"\n    ...>\n    ...> Oidcc.retrieve_token(\n    ...>   auth_code,\n    ...>   pid,\n    ...>   \"client_id\",\n    ...>   \"client_secret\",\n    ...>   %{redirect_uri: \"https://my.server/return\"}\n    ...> )\n    ...> # => {:ok, %Oidcc.Token{}}","ref":"Oidcc.html#retrieve_token/5-examples"},{"type":"function","title":"Oidcc.retrieve_userinfo/5","doc":"Load userinfo for the given token","ref":"Oidcc.html#retrieve_userinfo/5"},{"type":"function","title":"Examples - Oidcc.retrieve_userinfo/5","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> # Get access_token from Oidcc.Token.retrieve/3\n    ...> access_token = \"access_token\"\n    ...>\n    ...> Oidcc.retrieve_userinfo(\n    ...>   access_token,\n    ...>   pid,\n    ...>   \"client_id\",\n    ...>   \"client_secret\",\n    ...>   %{expected_subject: \"sub\"}\n    ...> )\n    ...> # => {:ok, %{\"sub\" => \"sub\"}}","ref":"Oidcc.html#retrieve_userinfo/5-examples"},{"type":"module","title":"Oidcc.Authorization","doc":"Functions to start an OpenID Connect Authorization","ref":"Oidcc.Authorization.html"},{"type":"function","title":"Oidcc.Authorization.create_redirect_url/2","doc":"Create Auth Redirect URL\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.create_redirect_url/4`.","ref":"Oidcc.Authorization.html#create_redirect_url/2"},{"type":"function","title":"Examples - Oidcc.Authorization.create_redirect_url/2","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://accounts.google.com\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> {:ok, _redirect_uri} =\n    ...>   Oidcc.Authorization.create_redirect_url(\n    ...>     client_context,\n    ...>     %{redirect_uri: \"https://my.server/return\"}\n    ...>   )","ref":"Oidcc.Authorization.html#create_redirect_url/2-examples"},{"type":"module","title":"Oidcc.ClientContext","doc":"Client Configuration for authorization, token exchange and userinfo\n\nFor most projects, it makes sense to use\n`Oidcc.ProviderConfiguration.Worker` and the high-level\ninterface of `Oidcc`. In that case direct usage of this\nmodule is not needed.","ref":"Oidcc.ClientContext.html"},{"type":"function","title":"Oidcc.ClientContext.from_configuration_worker/4","doc":"Create Client Context from a `Oidcc.ProviderConfiguration.Worker`","ref":"Oidcc.ClientContext.html#from_configuration_worker/4"},{"type":"function","title":"Examples - Oidcc.ClientContext.from_configuration_worker/4","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\",\n    ...>   name: __MODULE__.GoogleConfigProvider\n    ...> })\n    ...>\n    ...> {:ok, %Oidcc.ClientContext{}} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     __MODULE__.GoogleConfigProvider,\n    ...>     \"client_id\",\n    ...>     \"client_Secret\"\n    ...>   )\n    ...>\n    ...> {:ok, %Oidcc.ClientContext{}} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_Secret\",\n    ...>     %{client_jwks: JOSE.JWK.generate_key(16)}\n    ...>   )","ref":"Oidcc.ClientContext.html#from_configuration_worker/4-examples"},{"type":"function","title":"Oidcc.ClientContext.from_manual/5","doc":"Create Client Context manually","ref":"Oidcc.ClientContext.html#from_manual/5"},{"type":"function","title":"Examples - Oidcc.ClientContext.from_manual/5","doc":"iex> {:ok, {configuration, _expiry}} =\n    ...>   Oidcc.ProviderConfiguration.load_configuration(\n    ...>     \"https://login.salesforce.com\"\n    ...>   )\n    ...>\n    ...> {:ok, {jwks, _expiry}} =\n    ...>   Oidcc.ProviderConfiguration.load_jwks(\n    ...>     configuration.jwks_uri\n    ...>   )\n    ...>\n    ...> %Oidcc.ClientContext{} =\n    ...>   Oidcc.ClientContext.from_manual(\n    ...>     configuration,\n    ...>     jwks,\n    ...>     \"client_id\",\n    ...>     \"client_Secret\",\n    ...>     %{client_jwks: JOSE.JWK.generate_key(16)}\n    ...>   )","ref":"Oidcc.ClientContext.html#from_manual/5-examples"},{"type":"type","title":"Oidcc.ClientContext.authenticated_t/0","doc":"","ref":"Oidcc.ClientContext.html#t:authenticated_t/0"},{"type":"type","title":"Oidcc.ClientContext.t/0","doc":"","ref":"Oidcc.ClientContext.html#t:t/0"},{"type":"type","title":"Oidcc.ClientContext.unauthenticated_t/0","doc":"","ref":"Oidcc.ClientContext.html#t:unauthenticated_t/0"},{"type":"module","title":"Oidcc.ClientRegistration","doc":"Dynamic Client Registration Utilities","ref":"Oidcc.ClientRegistration.html"},{"type":"module","title":"Telemetry - Oidcc.ClientRegistration","doc":"* `[:oidcc, :register_client, :start]`\n  * Description: Emitted at the start of registering the client\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string()}`\n\n* `[:oidcc, :register_client, :stop]`\n  * Description: Emitted at the end of registering the client\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string()}`\n\n* `[:oidcc, :register_client, :exception]`\n  * Description: Emitted at the end of registering the client\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string()}`","ref":"Oidcc.ClientRegistration.html#module-telemetry"},{"type":"function","title":"Oidcc.ClientRegistration.register/3","doc":"Register Client","ref":"Oidcc.ClientRegistration.html#register/3"},{"type":"function","title":"Examples - Oidcc.ClientRegistration.register/3","doc":"iex> {:ok, {provider_configuration, _expiry}} =\n    ...>   Oidcc.ProviderConfiguration.load_configuration(\"https://accounts.google.com\")\n    ...>\n    ...> Oidcc.ClientRegistration.register(\n    ...>   provider_configuration,\n    ...>   %Oidcc.ClientRegistration{\n    ...>     redirect_uris: [\"https://your.application.com/oidcc/callback\"]\n    ...>   },\n    ...>   %{initial_access_token: \"optional token you got from the provider\"}\n    ...> )\n    ...> # {:ok, %Oidcc.ClientRegistration.Response{\n    ...> #   client_id: client_id,\n    ...> #   client_secret: client_secret\n    ...> # }}","ref":"Oidcc.ClientRegistration.html#register/3-examples"},{"type":"type","title":"Oidcc.ClientRegistration.t/0","doc":"Client Metdata Struct\n\nSee https://openid.net/specs/openid-connect-registration-1_0.html#ClientMetadata and\nhttps://openid.net/specs/openid-connect-rpinitiated-1_0.html#ClientMetadata","ref":"Oidcc.ClientRegistration.html#t:t/0"},{"type":"module","title":"Oidcc.ClientRegistration.Response","doc":"Client Registration Response Struct","ref":"Oidcc.ClientRegistration.Response.html"},{"type":"type","title":"Oidcc.ClientRegistration.Response.t/0","doc":"Client Registration Response Struct\n\nSee https://openid.net/specs/openid-connect-registration-1_0.html#RegistrationResponse","ref":"Oidcc.ClientRegistration.Response.html#t:t/0"},{"type":"module","title":"Oidcc.Logout","doc":"Logout from the OpenID Provider","ref":"Oidcc.Logout.html"},{"type":"function","title":"Oidcc.Logout.initiate_url/3","doc":"Initiate URI for Relaying Party initated Logout\n\nSee https://openid.net/specs/openid-connect-rpinitiated-1_0.html#RPLogout\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.initiate_logout_url/4`.","ref":"Oidcc.Logout.html#initiate_url/3"},{"type":"function","title":"Examples - Oidcc.Logout.initiate_url/3","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://erlef-test-w4a8z2.zitadel.cloud\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     :unauthenticated\n    ...>   )\n    ...>\n    ...> # Get `token` from `Oidcc.retrieve_token/5`\n    ...> token = \"token\"\n    ...>\n    ...> {:ok, _redirect_uri} =\n    ...>   Oidcc.Logout.initiate_url(\n    ...>     token,\n    ...>     client_context,\n    ...>     %{post_logout_redirect_uri: \"https://my.server/return\"}\n    ...>   )","ref":"Oidcc.Logout.html#initiate_url/3-examples"},{"type":"module","title":"Oidcc.ProviderConfiguration","doc":"Tooling to load and parse Openid Configuration","ref":"Oidcc.ProviderConfiguration.html"},{"type":"module","title":"Telemetry - Oidcc.ProviderConfiguration","doc":"* `[:oidcc, :load_configuration, :start]`\n  * Description: Emitted at the start of loading the provider configuration\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string()}`\n\n* `[:oidcc, :load_configuration, :stop]`\n  * Description: Emitted at the end of loading the provider configuration\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string()}`\n\n* `[:oidcc, :load_configuration, :exception]`\n  * Description: Emitted at the end of loading the provider configuration\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string()}`\n\n* `[:oidcc, :load_jwks, :start]`\n  * Description: Emitted at the start of loading the provider jwks\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{jwks_uri: :uri_string.uri_string()}`\n\n* `[:oidcc, :load_jwks, :stop]`\n  * Description: Emitted at the end of loading the provider jwks\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{jwks_uri: :uri_string.uri_string()}`\n\n* `[:oidcc, :load_jwks, :exception]`\n  * Description: Emitted at the end of loading the provider jwks\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{jwks_uri: :uri_string.uri_string()}`","ref":"Oidcc.ProviderConfiguration.html#module-telemetry"},{"type":"function","title":"Oidcc.ProviderConfiguration.decode_configuration/2","doc":"Decode JSON into OpenID configuration","ref":"Oidcc.ProviderConfiguration.html#decode_configuration/2"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.decode_configuration/2","doc":"iex> {:ok, {{~c\"HTTP/1.1\",200, ~c\"OK\"}, _headers, body}} =\n    ...>   :httpc.request(\"https://accounts.google.com/.well-known/openid-configuration\")\n    ...>\n    ...> decoded_json = body |> to_string() |> JOSE.decode()\n    ...>\n    ...> {:ok, %ProviderConfiguration{issuer: \"https://accounts.google.com\"}} =\n    ...>   Oidcc.ProviderConfiguration.decode_configuration(decoded_json)","ref":"Oidcc.ProviderConfiguration.html#decode_configuration/2-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.load_configuration/2","doc":"Load OpenID Configuration","ref":"Oidcc.ProviderConfiguration.html#load_configuration/2"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.load_configuration/2","doc":"iex> {:ok, {\n    ...>   %ProviderConfiguration{issuer: \"https://accounts.google.com\"},\n    ...>   _expiry\n    ...> }} = Oidcc.ProviderConfiguration.load_configuration(\"https://accounts.google.com\")","ref":"Oidcc.ProviderConfiguration.html#load_configuration/2-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.load_jwks/2","doc":"Load JWKs","ref":"Oidcc.ProviderConfiguration.html#load_jwks/2"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.load_jwks/2","doc":"iex> {:ok, {%JOSE.JWK{}, _expiry}} =\n    ...>   Oidcc.ProviderConfiguration.load_jwks(\"https://www.googleapis.com/oauth2/v3/certs\")","ref":"Oidcc.ProviderConfiguration.html#load_jwks/2-examples"},{"type":"type","title":"Oidcc.ProviderConfiguration.t/0","doc":"Configuration Struct\n\nFor details on the fields see:\n* https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata\n* https://datatracker.ietf.org/doc/html/draft-jones-oauth-discovery-01#section-4.1\n* https://openid.net/specs/openid-connect-rpinitiated-1_0.html#OPMetadata","ref":"Oidcc.ProviderConfiguration.html#t:t/0"},{"type":"module","title":"Oidcc.ProviderConfiguration.Worker","doc":"OIDC Config Provider Worker\n\nLoads and continuously refreshes the OIDC configuration and JWKs","ref":"Oidcc.ProviderConfiguration.Worker.html"},{"type":"module","title":"Usage in Supervisor - Oidcc.ProviderConfiguration.Worker","doc":"```elixir\nSupervisor.init([\n  {Oidcc.ProviderConfiguration.Worker, %{issuer: \"https://accounts.google.com\"}}\n], strategy: :one_for_one)\n```","ref":"Oidcc.ProviderConfiguration.Worker.html#module-usage-in-supervisor"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.child_spec/1","doc":"","ref":"Oidcc.ProviderConfiguration.Worker.html#child_spec/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.get_jwks/1","doc":"Get Parsed Jwks","ref":"Oidcc.ProviderConfiguration.Worker.html#get_jwks/1"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.Worker.get_jwks/1","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\"\n    ...> })\n    ...> %JOSE.JWK{} =\n    ...>   Oidcc.ProviderConfiguration.Worker.get_jwks(pid)","ref":"Oidcc.ProviderConfiguration.Worker.html#get_jwks/1-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.get_provider_configuration/1","doc":"Get Configuration","ref":"Oidcc.ProviderConfiguration.Worker.html#get_provider_configuration/1"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.Worker.get_provider_configuration/1","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\"\n    ...> })\n    ...> %Oidcc.ProviderConfiguration{issuer: \"https://accounts.google.com\"} =\n    ...>   Oidcc.ProviderConfiguration.Worker.get_provider_configuration(pid)","ref":"Oidcc.ProviderConfiguration.Worker.html#get_provider_configuration/1-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.refresh_configuration/1","doc":"Refresh Configuration","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_configuration/1"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.Worker.refresh_configuration/1","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\"\n    ...> })\n    ...> :ok = Oidcc.ProviderConfiguration.Worker.refresh_configuration(pid)","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_configuration/1-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.refresh_jwks/1","doc":"Refresh JWKs","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_jwks/1"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.Worker.refresh_jwks/1","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\"\n    ...> })\n    ...> :ok = Oidcc.ProviderConfiguration.Worker.refresh_jwks(pid)","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_jwks/1-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.refresh_jwks_for_unknown_kid/2","doc":"Refresh JWKs if the provided `Kid` is not matching any currently loaded keys","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_jwks_for_unknown_kid/2"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.Worker.refresh_jwks_for_unknown_kid/2","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\"\n    ...> })\n    ...> :ok = Oidcc.ProviderConfiguration.Worker.refresh_jwks_for_unknown_kid(pid, \"kid\")","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_jwks_for_unknown_kid/2-examples"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.start_link/1","doc":"Start Configuration Worker","ref":"Oidcc.ProviderConfiguration.Worker.html#start_link/1"},{"type":"function","title":"Examples - Oidcc.ProviderConfiguration.Worker.start_link/1","doc":"iex> {:ok, _pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>   issuer: \"https://accounts.google.com\",\n    ...>   name: __MODULE__.GoogleConfigProvider\n    ...> })","ref":"Oidcc.ProviderConfiguration.Worker.html#start_link/1-examples"},{"type":"type","title":"Oidcc.ProviderConfiguration.Worker.opts/0","doc":"See `t:oidcc_provider_configuration_worker.opts/0`","ref":"Oidcc.ProviderConfiguration.Worker.html#t:opts/0"},{"type":"module","title":"Oidcc.Token","doc":"Facilitate OpenID Code/Token Exchanges","ref":"Oidcc.Token.html"},{"type":"module","title":"Telemetry - Oidcc.Token","doc":"* `[:oidcc, :request_token, :start]`\n  * Description: Emitted at the start of requesting a code token\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :request_token, :stop]`\n  * Description: Emitted at the end of requesting a code token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :request_token, :exception]`\n  * Description: Emitted at the end of requesting a code token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :refresh_token, :start]`\n  * Description: Emitted at the start of refreshing a token\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :refresh_token, :stop]`\n  * Description: Emitted at the end of refreshing a token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :refresh_token, :exception]`\n  * Description: Emitted at the end of refreshing a token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :jwt_profile_token, :start]`\n  * Description: Emitted at the start of exchanging a JWT profile token\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :jwt_profile_token, :stop]`\n  * Description: Emitted at the end of exchanging a JWT profile token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :jwt_profile_token, :exception]`\n  * Description: Emitted at the end of exchanging a JWT profile token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :client_credentials, :start]`\n  * Description: Emitted at the start of requesting a client credentials token\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :client_credentials, :stop]`\n  * Description: Emitted at the end of requesting a client credentials token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :client_credentials, :exception]`\n  * Description: Emitted at the end of requesting a client credentials token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`","ref":"Oidcc.Token.html#module-telemetry"},{"type":"function","title":"Oidcc.Token.client_credentials/2","doc":"Retrieve Client Credential Token\n\nSee https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.client_credentials_token/4`.","ref":"Oidcc.Token.html#client_credentials/2"},{"type":"function","title":"Examples - Oidcc.Token.client_credentials/2","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://erlef-test-w4a8z2.zitadel.cloud\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     System.fetch_env!(\"CLIENT_CREDENTIALS_CLIENT_ID\"),\n    ...>     System.fetch_env!(\"CLIENT_CREDENTIALS_CLIENT_SECRET\")\n    ...>   )\n    ...>\n    ...> {:ok, %Oidcc.Token{}} =\n    ...>   Oidcc.Token.client_credentials(\n    ...>     client_context,\n    ...>     %{scope: [\"scope\"]}\n    ...>   )","ref":"Oidcc.Token.html#client_credentials/2-examples"},{"type":"function","title":"Oidcc.Token.jwt_profile/4","doc":"Retrieve JSON Web Token (JWT) Profile Token\n\nSee https://datatracker.ietf.org/doc/html/rfc7523#section-4\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.jwt_profile_token/6`.","ref":"Oidcc.Token.html#jwt_profile/4"},{"type":"function","title":"Examples - Oidcc.Token.jwt_profile/4","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://erlef-test-w4a8z2.zitadel.cloud\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> %{\"key\" => key, \"keyId\" => kid, \"userId\" => subject} = \"JWT_PROFILE\"\n    ...>   |> System.fetch_env!()\n    ...>   |> JOSE.decode()\n    ...>\n    ...> jwk = JOSE.JWK.from_pem(key)\n    ...>\n    ...> {:ok, %Oidcc.Token{}} =\n    ...>   Oidcc.Token.jwt_profile(\n    ...>     subject,\n    ...>     client_context,\n    ...>     jwk,\n    ...>     %{scope: [\"urn:zitadel:iam:org:project:id:zitadel:aud\"], kid: kid}\n    ...>   )","ref":"Oidcc.Token.html#jwt_profile/4-examples"},{"type":"function","title":"Oidcc.Token.refresh/3","doc":"Refresh Token\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.refresh_token/5`.","ref":"Oidcc.Token.html#refresh/3"},{"type":"function","title":"Examples - Oidcc.Token.refresh/3","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> # Get refresh_token fromm redirect\n    ...> refresh_token = \"refresh_token\"\n    ...>\n    ...> Oidcc.Token.refresh(\n    ...>   refresh_token,\n    ...>   client_context,\n    ...>   %{expected_subject: \"sub\"}\n    ...> )\n    ...> # => {:ok, %Oidcc.Token{}}","ref":"Oidcc.Token.html#refresh/3-examples"},{"type":"function","title":"Oidcc.Token.retrieve/3","doc":"retrieve the token using the authcode received before and directly validate\nthe result.\n\nthe authcode was sent to the local endpoint by the OpenId Connect provider,\nusing redirects\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.retrieve_token/5`.","ref":"Oidcc.Token.html#retrieve/3"},{"type":"function","title":"Examples - Oidcc.Token.retrieve/3","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> # Get auth_code fromm redirect\n    ...> auth_code = \"auth_code\"\n    ...>\n    ...> Oidcc.Token.retrieve(\n    ...>   auth_code,\n    ...>   client_context,\n    ...>   %{redirect_uri: \"https://my.server/return\"}\n    ...> )\n    ...> # => {:ok, %Oidcc.Token{}}","ref":"Oidcc.Token.html#retrieve/3-examples"},{"type":"function","title":"Oidcc.Token.validate_id_token/3","doc":"Validate ID Token\n\nUsually the id token is validated using `retrieve/3`.\nIf you get the token passed from somewhere else, this function can validate it.","ref":"Oidcc.Token.html#validate_id_token/3"},{"type":"function","title":"Examples - Oidcc.Token.validate_id_token/3","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> #Get IdToken from somewhere\n    ...> id_token = \"id_token\"\n    ...>\n    ...> Oidcc.Token.validate_id_token(id_token, client_context, :any)\n    ...> # => {:ok, %{\"sub\" => \"sub\", ... }}","ref":"Oidcc.Token.html#validate_id_token/3-examples"},{"type":"type","title":"Oidcc.Token.t/0","doc":"","ref":"Oidcc.Token.html#t:t/0"},{"type":"module","title":"Oidcc.Token.Access","doc":"Access Token struct.\n\nSee `t::oidcc_token.access/0`","ref":"Oidcc.Token.Access.html"},{"type":"type","title":"Oidcc.Token.Access.t/0","doc":"","ref":"Oidcc.Token.Access.html#t:t/0"},{"type":"module","title":"Oidcc.Token.Id","doc":"ID Token struct","ref":"Oidcc.Token.Id.html"},{"type":"type","title":"Oidcc.Token.Id.t/0","doc":"","ref":"Oidcc.Token.Id.html#t:t/0"},{"type":"module","title":"Oidcc.Token.Refresh","doc":"Refresh Token struct","ref":"Oidcc.Token.Refresh.html"},{"type":"type","title":"Oidcc.Token.Refresh.t/0","doc":"","ref":"Oidcc.Token.Refresh.html#t:t/0"},{"type":"module","title":"Oidcc.TokenIntrospection","doc":"OAuth Token Introspection\n\nSee https://datatracker.ietf.org/doc/html/rfc7662","ref":"Oidcc.TokenIntrospection.html"},{"type":"module","title":"Telemetry - Oidcc.TokenIntrospection","doc":"* `[:oidcc, :introspect_token, :start]`\n  * Description: Emitted at the start of introspecting the token\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :introspect_token, :stop]`\n  * Description: Emitted at the end of introspecting the token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :introspect_token, :exception]`\n  * Description: Emitted at the end of introspecting the token\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`","ref":"Oidcc.TokenIntrospection.html#module-telemetry"},{"type":"function","title":"Oidcc.TokenIntrospection.introspect/3","doc":"Introspect the given access token\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.introspect_token/5`.","ref":"Oidcc.TokenIntrospection.html#introspect/3"},{"type":"function","title":"Examples - Oidcc.TokenIntrospection.introspect/3","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> Oidcc.TokenIntrospection.introspect(\n    ...>   \"access_token\",\n    ...>   client_context\n    ...> )\n    ...> # => {:ok, %Oidcc.TokenIntrospection{}}","ref":"Oidcc.TokenIntrospection.html#introspect/3-examples"},{"type":"type","title":"Oidcc.TokenIntrospection.t/0","doc":"","ref":"Oidcc.TokenIntrospection.html#t:t/0"},{"type":"module","title":"Oidcc.Userinfo","doc":"OpenID Connect Userinfo\n\nSee https://openid.net/specs/openid-connect-core-1_0.html#UserInfo","ref":"Oidcc.Userinfo.html"},{"type":"module","title":"Telemetry - Oidcc.Userinfo","doc":"* `[:oidcc, :userinfo, :start]`\n  * Description: Emitted at the start of loading userinfo\n  * Measurements: `%{system_time: non_neg_integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :userinfo, :stop]`\n  * Description: Emitted at the end of loading userinfo\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`\n\n* `[:oidcc, :userinfo, :exception]`\n  * Description: Emitted at the end of loading userinfo\n  * Measurements: `%{duration: integer(), monotonic_time: integer()}`\n  * Metadata: `%{issuer: :uri_string.uri_string(), client_id: String.t()}`","ref":"Oidcc.Userinfo.html#module-telemetry"},{"type":"function","title":"Oidcc.Userinfo.retrieve/3","doc":"Load userinfo for the given token\n\nFor a high level interface using `Oidcc.ProviderConfiguration.Worker`\nsee `Oidcc.retrieve_userinfo/5`.","ref":"Oidcc.Userinfo.html#retrieve/3"},{"type":"function","title":"Examples - Oidcc.Userinfo.retrieve/3","doc":"iex> {:ok, pid} =\n    ...>   Oidcc.ProviderConfiguration.Worker.start_link(%{\n    ...>     issuer: \"https://api.login.yahoo.com\"\n    ...>   })\n    ...>\n    ...> {:ok, client_context} =\n    ...>   Oidcc.ClientContext.from_configuration_worker(\n    ...>     pid,\n    ...>     \"client_id\",\n    ...>     \"client_secret\"\n    ...>   )\n    ...>\n    ...> # Get access_token from Oidcc.Token.retrieve/3\n    ...> access_token = \"access_token\"\n    ...>\n    ...> Oidcc.Userinfo.retrieve(\n    ...>   access_token,\n    ...>   client_context,\n    ...>   %{expected_subject: \"sub\"}\n    ...> )\n    ...> # => {:ok, %{\"sub\" => \"sub\"}}","ref":"Oidcc.Userinfo.html#retrieve/3-examples"},{"type":"extras","title":"README","doc":"# oidcc\n\nOpenID Connect client library for Erlang.\n\n[![EEF Security WG project](https://img.shields.io/badge/EEF-Security-black)](https://github.com/erlef/security-wg)\n[![Main Branch](https://github.com/erlef/oidcc/actions/workflows/branch_main.yml/badge.svg?branch=main)](https://github.com/erlef/oidcc/actions/workflows/branch_main.yml)\n[![Module Version](https://img.shields.io/hexpm/v/oidcc.svg)](https://hex.pm/packages/oidcc)\n[![Total Download](https://img.shields.io/hexpm/dt/oidcc.svg)](https://hex.pm/packages/oidcc)\n[![License](https://img.shields.io/hexpm/l/oidcc.svg)](https://github.com/erlef/oidcc/blob/main/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/erlef/oidcc.svg)](https://github.com/erlef/oidcc/commits/master)\n[![Coverage Status](https://coveralls.io/repos/github/erlef/oidcc/badge.svg?branch=main)](https://coveralls.io/github/erlef/oidcc?branch=main)\n\n \n\n \n   \n   \n   \n \n\nOpenID Certified by [Jonatan Männchen](https://github.com/maennchen) at the\n[Erlang Ecosystem Foundation](https://github.com/erlef) of multiple Relaying\nParty conformance profiles of the OpenID Connect protocol:\nFor details, check the\n[Conformance Documentation](https://github.com/erlef/oidcc/tree/openid-foundation-certification).\n\n \n\n \n   \n   \n   \n \n\nThe refactoring for `v3` and the certification is funded as an\n[Erlang Ecosystem Foundation](https://erlef.org/) stipend entered by the\n[Security Working Group](https://erlef.org/wg/security).","ref":"readme.html"},{"type":"extras","title":"Supported Features - README","doc":"* [Discovery](https://openid.net/specs/openid-connect-discovery-1_0.html)\n  (`[ISSUER]/.well-known/openid-configuration`)\n* [Client Registration](https://openid.net/specs/openid-connect-registration-1_0.html)\n* Authorization (Code Flow)\n  * [Request Object](https://openid.net/specs/openid-connect-core-1_0.html#RequestObject)\n  * [PKCE](https://oauth.net/2/pkce/)\n* Token\n  * Authorization: `client_secret_basic`, `client_secret_post`,\n    `client_secret_jwt`, and `private_key_jwt`\n  * Grant Types: `authorization_code`, `refresh_token`, `jwt_bearer`, and\n    `client_credentials`\n  * Automatic JWK Refreshing when needed\n* Userinfo\n  * [JWT Response](https://openid.net/specs/openid-connect-core-1_0.html#UserInfoResponse)\n  * [Aggregated and Distributed Claims](https://openid.net/specs/openid-connect-core-1_0.html#AggregatedDistributedClaims)\n* [Token Introspection](https://datatracker.ietf.org/doc/html/rfc7662)\n* Logout\n  * [RP-Initiated](https://openid.net/specs/openid-connect-rpinitiated-1_0.html)","ref":"readme.html#supported-features"},{"type":"extras","title":"Setup - README","doc":"**Please note that the minimum supported Erlang OTP version is OTP26.**\n\n#","ref":"readme.html#setup"},{"type":"extras","title":"Erlang - README","doc":"**directly**\n\n```erlang\n{ok, Pid} =\n  oidcc_provider_configuration_worker:start_link(#{\n    issuer => <<\"https://accounts.google.com\">>,\n    name => {local, google_config_provider}\n  }).\n```\n\n**via `supervisor`**\n\n```erlang\n-behaviour(supervisor).\n\n%% ...\n\ninit(_Args) ->\n  SupFlags = #{strategy => one_for_one},\n  ChildSpecs = [#{id => oidcc_provider_configuration_worker,\n                  start => {oidcc_provider_configuration_worker, start_link, [\n                    #{issuer => \"https://accounts.google.com\",\n                      name => {local, myapp_oidcc_config_provider}}\n                  ]},\n                  shutdown => brutal_kill}],\n  {ok, {SupFlags, ChildSpecs}}.\n```\n\n#","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - README","doc":"**directly**\n\n```elixir\n{:ok, _pid} =\n  Oidcc.ProviderConfiguration.Worker.start_link(%{\n  issuer: \"https://accounts.google.com\",\n  name: Myapp.OidccConfigProvider\n})\n```\n\n**via `Supervisor`**\n\n```elixir\nSupervisor.init([\n  {Oidcc.ProviderConfiguration.Worker, %{\n    issuer: \"https://accounts.google.com\",\n    name: Myapp.OidccConfigProvider\n  }}\n], strategy: :one_for_one)\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Usage - README","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"Companion libraries - README","doc":"`oidcc` offers integrations for various libraries:\n\n<!-- TODO: Uncomment when available -->\n\n- [`oidcc_cowboy`](https://hex.pm/packages/oidcc_cowboy) - Integrations for\n  [`cowboy`](https://hex.pm/packages/cowboy)\n- [`oidcc_plug`](https://hex.pm/packages/oidcc_plug) - Integrations for\n  [`plug`](https://hex.pm/packages/plug) and\n  [`phoenix`](https://hex.pm/packages/phoenix)\n- [`phx_gen_oidcc`](https://hex.pm/packages/phx_gen_oidcc) - Setup Generator for\n  [`phoenix`](https://hex.pm/packages/phoenix)\n- [`ueberauth_oidcc`](https://hex.pm/packages/ueberauth_oidcc) - Integration for\n  [`ueberauth`](https://hex.pm/packages/ueberauth)\n\n#","ref":"readme.html#companion-libraries"},{"type":"extras","title":"Erlang - README","doc":"```erlang\n%% Create redirect URI for authorization\n{ok, RedirectUri} =\n  oidcc:create_redirect_url(myapp_oidcc_config_provider,\n                            <<\"client_id\">>,\n                            <<\"client_secret\">>\n                            #{redirect_uri: <<\"https://example.com/callback\"}),\n\n%% Redirect user to `RedirectUri`\n\n%% Retrieve `code` query / form param from redirect back\n\n%% Exchange code for token\n{ok, Token} =\n  oidcc:retrieve_token(AuthCode,\n                       myapp_oidcc_config_provider,\n                       <<\"client_id\">>,\n                       <<\"client_secret\">>,\n                       #{redirect_uri => <<\"https://example.com/callback\">>}),\n\n%% Load userinfo for token\n{ok, Claims} =\n  oidcc:retrieve_userinfo(Token,\n                          myapp_oidcc_config_provider,\n                          <<\"client_id\">>,\n                          <<\"client_secret\">>,\n                          #{}),\n\n%% Load introspection for access token\n{ok, Introspection} =\n  oidcc:introspect_token(Token,\n                         myapp_oidcc_config_provider,\n                         <<\"client_id\">>,\n                         <<\"client_secret\">>,\n                         #{}),\n\n%% Refresh token when it expires\n{ok, RefreshedToken} =\n  oidcc:refresh_token(Token,\n                      myapp_oidcc_config_provider,\n                      <<\"client_id\">>,\n                      <<\"client_secret\">>,\n                      #{}).\n```\n\nfor more details, see https://hexdocs.pm/oidcc/oidcc.html\n\n#","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - README","doc":"```elixir\n# Create redirect URI for authorization\n{:ok, redirect_uri} =\n  Oidcc.create_redirect_url(\n    Myapp.OidccConfigProvider,\n    \"client_id\",\n    \"client_secret\",\n    %{redirect_uri: \"https://example.com/callback\"}\n  )\n\n# Redirect user to `redirect_uri`\n\n# Retrieve `code` query / form param from redirect back\n\n# Exchange code for token\n{:ok, token} = Oidcc.retrieve_token(\n  auth_code,\n    Myapp.OidccConfigProvider,\n  \"client_id\",\n  \"client_secret\",\n  %{redirect_uri: \"https://example.com/callback\"}\n)\n\n# Load userinfo for token\n{:ok, claims} = Oidcc.retrieve_userinfo(\n  token,\n  Myapp.OidccConfigProvider,\n  \"client_id\",\n  \"client_secret\",\n  %{expected_subject: \"sub\"}\n)\n\n# Load introspection for access token\n{:ok, introspection} = Oidcc.introspect_token(\n  token,\n  Myapp.OidccConfigProvider,\n  \"client_id\",\n  \"client_secret\"\n)\n\n# Refresh token when it expires\n{:ok, refreshed_token} = Oidcc.refresh_token(\n  token,\n  Myapp.OidccConfigProvider,\n  \"client_id\",\n  \"client_secret\"\n)\n```\n\nfor more details, see https://hexdocs.pm/oidcc/Oidcc.html","ref":"readme.html#elixir"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}